#include <Wire.h>
#include <LCD.h>
#include <OneWire.h>
#include <LiquidCrystal_I2C.h>
#include <DallasTemperature.h>


volatile uint8_t tic, Dimmer1, Dimm=255; 

/*----( Declare Constants )----*/
#define I2C_ADDR    0x20          // Define I2C Address for the PCF8574A 
                                  //---(Following are the PCF8574 pin assignments to LCD connections )----
                                  // This are different than earlier/different I2C LCD displays
#define BACKLIGHT_PIN  7
#define En_pin  4
#define Rw_pin  5
#define Rs_pin  6
#define D4_pin  0
#define D5_pin  1
#define D6_pin  2
#define D7_pin  3

#define  LED_OFF  1
#define  LED_ON  0


#define ONE_WIRE_BUS 8
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);

byte BuzzerPIN = 10;             // выход динамика
byte OtborKRUTILKA  = A1;        // пин подключения крутилки диммера
byte data[9];                    // для хранения данных от датчика
byte i;                          // счетчик
float Tp=0;
float Ts=0;
int alarm=0;
unsigned char tempr[47]={80,10,10,15,110,100,85,85,80,80,75,70,60,50,30,80,50,20,70,40,20,70,30,30,45,55,40,30,50,70,72,48,60,30,45,45,40,25,15,20,30,25,35,10,20,10,5};
unsigned char spirt[47]={99,11,11,11,108, 88,70,41,45,37,31,25,22,19,17,15,14,11,11,10,10,16, 8, 7,13,11, 9, 9,11,11,11,10,10, 6,12,11,11, 8, 9,10,11, 8,18, 4,10,11,9};


LiquidCrystal_I2C  lcd(I2C_ADDR,En_pin,Rw_pin,Rs_pin,D4_pin,D5_pin,D6_pin,D7_pin);

void setup()   
/*----( SETUP: RUNS ONCE )----*/
{
  lcd.begin (16,2);                    // initialize the lcd 
// Switch on the backlight
  lcd.setBacklightPin(BACKLIGHT_PIN,NEGATIVE);
  lcd.setBacklight(LED_ON);
  
  sensors.begin();                                                          // запустить таймер
}

int GetSpirt(unsigned int T)
{
    
    int T1=7815;
    int S1=972;              
    char n=46;
    if (T<T1) return -1; 
    while (n>=0)
    {                  
        if (T<T1+tempr[n])
        {
            //Нашли промежуток для интерполящии
            S1 = S1 - (T-T1)*spirt[n] / tempr[n];
            return S1; 
        

}
        T1=T1+tempr[n];
        S1=S1-spirt[n];
        n--;
    }
    return 0;

}

void loop()   /*----( LOOP: RUNS OVER AND OVER AGAIN )----*/
{
  sensors.requestTemperatures(); // Send the command to get temperatures
  Tp=sensors.getTempCByIndex(0);
  Ts=GetSpirt(int(Tp*100))/10;
  alarm=map(analogRead(OtborKRUTILKA),0,1023,0,100);
 
  if (Ts <= alarm && Tp > 78.2) {tone(BuzzerPIN, 2000);} else {noTone(BuzzerPIN);}            // это для того, чтобы при глюке датчика (обычно при переключениях           
  // запускаем конвертацию
    delay(100);
    lcd.backlight();  //Backlight ON if under program control
    lcd.clear();
    lcd.setCursor(0,0); //Start at character 0 on line 0
    lcd.print("T:");
    lcd.print(Tp);
    lcd.print(" Al:");
    lcd.print(alarm);
    lcd.setCursor(0,1); //Start at character 0 on line 0
    lcd.print("Alcohol %: ");
    lcd.print(Ts);
    
    
    
}    
